<html>
<head>
<title>OgreAxisAlignedBox.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreAxisAlignedBox.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreAxisAlignedBox_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">(Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef __AxisAlignedBox_H_</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define __AxisAlignedBox_H_</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="comment">// Precompiler options</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="OgreVector3_8h.html">OgreVector3.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="OgreMatrix4_8h.html">OgreMatrix4.h</a>&quot;</span>
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 <span class="keyword">namespace </span>Ogre {
<a name="l00054"></a><a class="code" href="classOgre_1_1AxisAlignedBox.html">00054</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1AxisAlignedBox.html" title="A 3D box aligned with the x/y/z axes.">AxisAlignedBox</a>
<a name="l00055"></a>00055     {
<a name="l00056"></a>00056     <span class="keyword">public</span>:
<a name="l00057"></a><a class="code" href="classOgre_1_1AxisAlignedBox.html#a49fc600cdfc76dfaba2613ce3af2443e">00057</a>         <span class="keyword">enum</span> <a class="code" href="classOgre_1_1AxisAlignedBox.html#a49fc600cdfc76dfaba2613ce3af2443e">Extent</a>
<a name="l00058"></a>00058         {
<a name="l00059"></a><a class="code" href="classOgre_1_1AxisAlignedBox.html#a49fc600cdfc76dfaba2613ce3af2443ea5046ce9384ab8647fb3c58e03d5446c9">00059</a>             <a class="code" href="classOgre_1_1AxisAlignedBox.html#a49fc600cdfc76dfaba2613ce3af2443ea5046ce9384ab8647fb3c58e03d5446c9">EXTENT_NULL</a>,
<a name="l00060"></a><a class="code" href="classOgre_1_1AxisAlignedBox.html#a49fc600cdfc76dfaba2613ce3af2443eafa5a4b01ba1d49c7b3db966223bf6642">00060</a>             <a class="code" href="classOgre_1_1AxisAlignedBox.html#a49fc600cdfc76dfaba2613ce3af2443eafa5a4b01ba1d49c7b3db966223bf6642">EXTENT_FINITE</a>,
<a name="l00061"></a><a class="code" href="classOgre_1_1AxisAlignedBox.html#a49fc600cdfc76dfaba2613ce3af2443ea549926fd8188d52a8a579673de7b93a2">00061</a>             EXTENT_INFINITE
<a name="l00062"></a>00062         };
<a name="l00063"></a>00063     <span class="keyword">protected</span>:
<a name="l00064"></a>00064 
<a name="l00065"></a><a class="code" href="classOgre_1_1AxisAlignedBox.html#a958c03c0afd2eef4347d345bea8c94a5">00065</a>         <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> <a class="code" href="classOgre_1_1AxisAlignedBox.html#a958c03c0afd2eef4347d345bea8c94a5">mMinimum</a>;
<a name="l00066"></a><a class="code" href="classOgre_1_1AxisAlignedBox.html#a2254e8ef682cda1a96693637742c9834">00066</a>         <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> <a class="code" href="classOgre_1_1AxisAlignedBox.html#a2254e8ef682cda1a96693637742c9834">mMaximum</a>;
<a name="l00067"></a><a class="code" href="classOgre_1_1AxisAlignedBox.html#a756e8324082dc0b9f1d7926847711ef4">00067</a>         <a class="code" href="classOgre_1_1AxisAlignedBox.html#a49fc600cdfc76dfaba2613ce3af2443e">Extent</a> <a class="code" href="classOgre_1_1AxisAlignedBox.html#a756e8324082dc0b9f1d7926847711ef4">mExtent</a>;
<a name="l00068"></a><a class="code" href="classOgre_1_1AxisAlignedBox.html#a23b18d7cd01353725054049d66cd5a2a">00068</a>         <span class="keyword">mutable</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>* <a class="code" href="classOgre_1_1AxisAlignedBox.html#a23b18d7cd01353725054049d66cd5a2a">mCorners</a>;
<a name="l00069"></a>00069 
<a name="l00070"></a>00070     <span class="keyword">public</span>:
<a name="l00071"></a>00071         <span class="comment">/*</span>
<a name="l00072"></a>00072 <span class="comment">        1-----2</span>
<a name="l00073"></a>00073 <span class="comment">        /|    /|</span>
<a name="l00074"></a>00074 <span class="comment">        / |   / |</span>
<a name="l00075"></a>00075 <span class="comment">        5-----4  |</span>
<a name="l00076"></a>00076 <span class="comment">        |  0--|--3</span>
<a name="l00077"></a>00077 <span class="comment">        | /   | /</span>
<a name="l00078"></a>00078 <span class="comment">        |/    |/</span>
<a name="l00079"></a>00079 <span class="comment">        6-----7</span>
<a name="l00080"></a>00080 <span class="comment">        */</span>
<a name="l00081"></a><a class="code" href="classOgre_1_1AxisAlignedBox.html#a771c83dfb946e6d66c9ddf09fba7e5b3">00081</a>         <span class="keyword">typedef</span> <span class="keyword">enum</span> {
<a name="l00082"></a><a class="code" href="classOgre_1_1AxisAlignedBox.html#a771c83dfb946e6d66c9ddf09fba7e5b3a2ba07c11671eb44dae2015d45a9fa861">00082</a>             FAR_LEFT_BOTTOM = 0,
<a name="l00083"></a><a class="code" href="classOgre_1_1AxisAlignedBox.html#a771c83dfb946e6d66c9ddf09fba7e5b3a805a552d90a29ea9fd8c247500dcd92e">00083</a>             FAR_LEFT_TOP = 1,
<a name="l00084"></a><a class="code" href="classOgre_1_1AxisAlignedBox.html#a771c83dfb946e6d66c9ddf09fba7e5b3a83ef287678d55680f7d26c0e1a0af88b">00084</a>             FAR_RIGHT_TOP = 2,
<a name="l00085"></a><a class="code" href="classOgre_1_1AxisAlignedBox.html#a771c83dfb946e6d66c9ddf09fba7e5b3a82a1588bb8174e562e0e21a3469cd428">00085</a>             FAR_RIGHT_BOTTOM = 3,
<a name="l00086"></a><a class="code" href="classOgre_1_1AxisAlignedBox.html#a771c83dfb946e6d66c9ddf09fba7e5b3a03c007f742ece84e634533dad5655289">00086</a>             NEAR_RIGHT_BOTTOM = 7,
<a name="l00087"></a><a class="code" href="classOgre_1_1AxisAlignedBox.html#a771c83dfb946e6d66c9ddf09fba7e5b3ad7af8f1d62fb0717955df915775bba40">00087</a>             NEAR_LEFT_BOTTOM = 6,
<a name="l00088"></a><a class="code" href="classOgre_1_1AxisAlignedBox.html#a771c83dfb946e6d66c9ddf09fba7e5b3ab6b3c127e0bec403f8b162153fa8977c">00088</a>             NEAR_LEFT_TOP = 5,
<a name="l00089"></a><a class="code" href="classOgre_1_1AxisAlignedBox.html#a771c83dfb946e6d66c9ddf09fba7e5b3ab76a3b018615466de7e96bf65fed7696">00089</a>             NEAR_RIGHT_TOP = 4
<a name="l00090"></a>00090         } CornerEnum;
<a name="l00091"></a><a class="code" href="classOgre_1_1AxisAlignedBox.html#a848fa65c291ef9f898a48c686c9a0444">00091</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1AxisAlignedBox.html" title="A 3D box aligned with the x/y/z axes.">AxisAlignedBox</a>() : mMinimum(<a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>::ZERO), mMaximum(<a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>::UNIT_SCALE), mCorners(0)
<a name="l00092"></a>00092         {
<a name="l00093"></a>00093             <span class="comment">// Default to a null box </span>
<a name="l00094"></a>00094             setMinimum( -0.5, -0.5, -0.5 );
<a name="l00095"></a>00095             setMaximum( 0.5, 0.5, 0.5 );
<a name="l00096"></a>00096             mExtent = EXTENT_NULL;
<a name="l00097"></a>00097         }
<a name="l00098"></a><a class="code" href="classOgre_1_1AxisAlignedBox.html#a9abfa2f7b652f0418d6b5236cd18390e">00098</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1AxisAlignedBox.html" title="A 3D box aligned with the x/y/z axes.">AxisAlignedBox</a>(<a class="code" href="classOgre_1_1AxisAlignedBox.html#a49fc600cdfc76dfaba2613ce3af2443e">Extent</a> e) : mMinimum(<a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>::ZERO), mMaximum(<a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>::UNIT_SCALE), mCorners(0)
<a name="l00099"></a>00099         {
<a name="l00100"></a>00100             setMinimum( -0.5, -0.5, -0.5 );
<a name="l00101"></a>00101             setMaximum( 0.5, 0.5, 0.5 );
<a name="l00102"></a>00102             mExtent = e;
<a name="l00103"></a>00103         }
<a name="l00104"></a>00104 
<a name="l00105"></a><a class="code" href="classOgre_1_1AxisAlignedBox.html#a447e26afa784b2cbe61b5204f8dbf69f">00105</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1AxisAlignedBox.html" title="A 3D box aligned with the x/y/z axes.">AxisAlignedBox</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1AxisAlignedBox.html" title="A 3D box aligned with the x/y/z axes.">AxisAlignedBox</a> &amp; rkBox) : mMinimum(<a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>::ZERO), mMaximum(<a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>::UNIT_SCALE), mCorners(0)
<a name="l00106"></a>00106 
<a name="l00107"></a>00107         {
<a name="l00108"></a>00108             <span class="keywordflow">if</span> (rkBox.<a class="code" href="classOgre_1_1AxisAlignedBox.html#abeef4ea1111a90001287734529288749" title="Returns true if the box is null i.e.">isNull</a>())
<a name="l00109"></a>00109                 setNull();
<a name="l00110"></a>00110             <span class="keywordflow">else</span> <span class="keywordflow">if</span> (rkBox.<a class="code" href="classOgre_1_1AxisAlignedBox.html#a45665abec389ae0ecbea54a26956a633" title="Returns true if the box is infinite.">isInfinite</a>())
<a name="l00111"></a>00111                 setInfinite();
<a name="l00112"></a>00112             <span class="keywordflow">else</span>
<a name="l00113"></a>00113                 setExtents( rkBox.<a class="code" href="classOgre_1_1AxisAlignedBox.html#a958c03c0afd2eef4347d345bea8c94a5">mMinimum</a>, rkBox.<a class="code" href="classOgre_1_1AxisAlignedBox.html#a2254e8ef682cda1a96693637742c9834">mMaximum</a> );
<a name="l00114"></a>00114         }
<a name="l00115"></a>00115 
<a name="l00116"></a><a class="code" href="classOgre_1_1AxisAlignedBox.html#a376f0d3333f8c5e84e679a981b2cc4dd">00116</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1AxisAlignedBox.html" title="A 3D box aligned with the x/y/z axes.">AxisAlignedBox</a>( <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; min, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; max ) : mMinimum(<a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>::ZERO), mMaximum(<a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>::UNIT_SCALE), mCorners(0)
<a name="l00117"></a>00117         {
<a name="l00118"></a>00118             setExtents( min, max );
<a name="l00119"></a>00119         }
<a name="l00120"></a>00120 
<a name="l00121"></a><a class="code" href="classOgre_1_1AxisAlignedBox.html#ac500b5c0c4b894d031e5c53357586358">00121</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1AxisAlignedBox.html" title="A 3D box aligned with the x/y/z axes.">AxisAlignedBox</a>(
<a name="l00122"></a>00122             <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> mx, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> my, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> mz,
<a name="l00123"></a>00123             <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> Mx, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> My, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> Mz ) : mMinimum(<a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>::ZERO), mMaximum(<a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>::UNIT_SCALE), mCorners(0)
<a name="l00124"></a>00124         {
<a name="l00125"></a>00125             setExtents( mx, my, mz, Mx, My, Mz );
<a name="l00126"></a>00126         }
<a name="l00127"></a>00127 
<a name="l00128"></a><a class="code" href="classOgre_1_1AxisAlignedBox.html#afa0d6b257b3c1da62dd8944a02eae3f1">00128</a>         <a class="code" href="classOgre_1_1AxisAlignedBox.html" title="A 3D box aligned with the x/y/z axes.">AxisAlignedBox</a>&amp; operator=(<span class="keyword">const</span> <a class="code" href="classOgre_1_1AxisAlignedBox.html" title="A 3D box aligned with the x/y/z axes.">AxisAlignedBox</a>&amp; rhs)
<a name="l00129"></a>00129         {
<a name="l00130"></a>00130             <span class="comment">// Specifically override to avoid copying mCorners</span>
<a name="l00131"></a>00131             <span class="keywordflow">if</span> (rhs.<a class="code" href="classOgre_1_1AxisAlignedBox.html#abeef4ea1111a90001287734529288749" title="Returns true if the box is null i.e.">isNull</a>())
<a name="l00132"></a>00132                 setNull();
<a name="l00133"></a>00133             <span class="keywordflow">else</span> <span class="keywordflow">if</span> (rhs.<a class="code" href="classOgre_1_1AxisAlignedBox.html#a45665abec389ae0ecbea54a26956a633" title="Returns true if the box is infinite.">isInfinite</a>())
<a name="l00134"></a>00134                 setInfinite();
<a name="l00135"></a>00135             <span class="keywordflow">else</span>
<a name="l00136"></a>00136                 setExtents(rhs.<a class="code" href="classOgre_1_1AxisAlignedBox.html#a958c03c0afd2eef4347d345bea8c94a5">mMinimum</a>, rhs.<a class="code" href="classOgre_1_1AxisAlignedBox.html#a2254e8ef682cda1a96693637742c9834">mMaximum</a>);
<a name="l00137"></a>00137 
<a name="l00138"></a>00138             <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00139"></a>00139         }
<a name="l00140"></a>00140 
<a name="l00141"></a><a class="code" href="classOgre_1_1AxisAlignedBox.html#a6388a911df973ae067d9751ca74a57c4">00141</a>         ~<a class="code" href="classOgre_1_1AxisAlignedBox.html" title="A 3D box aligned with the x/y/z axes.">AxisAlignedBox</a>()
<a name="l00142"></a>00142         {
<a name="l00143"></a>00143             <span class="keywordflow">if</span> (mCorners)
<a name="l00144"></a>00144                 <a class="code" href="group__Memory.html#gacfd8dc937cf390c7bff05495f0dc10cf" title="Free the memory allocated with OGRE_MALLOC or OGRE_ALLOC_T. Category is required to be restated to en...">OGRE_FREE</a>(mCorners, <a class="code" href="group__Memory.html#gga830fab51be174d6f2849857cb1abb36aa8a55fa0fcaa8403bb51ca210f882ed90" title="Nodes, control data.">MEMCATEGORY_SCENE_CONTROL</a>);
<a name="l00145"></a>00145         }
<a name="l00146"></a>00146 
<a name="l00147"></a>00147 
<a name="l00150"></a><a class="code" href="classOgre_1_1AxisAlignedBox.html#a0ef53ae1514666961bb13fa170162273">00150</a>         <span class="keyword">inline</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; getMinimum(<span class="keywordtype">void</span>)<span class="keyword"> const</span>
<a name="l00151"></a>00151 <span class="keyword">        </span>{ 
<a name="l00152"></a>00152             <span class="keywordflow">return</span> mMinimum; 
<a name="l00153"></a>00153         }
<a name="l00154"></a>00154 
<a name="l00158"></a><a class="code" href="classOgre_1_1AxisAlignedBox.html#a8f7f70a7c229e3ee93d0fab42b177682">00158</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; getMinimum(<span class="keywordtype">void</span>)
<a name="l00159"></a>00159         { 
<a name="l00160"></a>00160             <span class="keywordflow">return</span> mMinimum; 
<a name="l00161"></a>00161         }
<a name="l00162"></a>00162 
<a name="l00165"></a><a class="code" href="classOgre_1_1AxisAlignedBox.html#a89c67352264aa62ee69283b25dca4982">00165</a>         <span class="keyword">inline</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; getMaximum(<span class="keywordtype">void</span>)<span class="keyword"> const</span>
<a name="l00166"></a>00166 <span class="keyword">        </span>{ 
<a name="l00167"></a>00167             <span class="keywordflow">return</span> mMaximum;
<a name="l00168"></a>00168         }
<a name="l00169"></a>00169 
<a name="l00173"></a><a class="code" href="classOgre_1_1AxisAlignedBox.html#a89e5714529366778551e87fffe4a9932">00173</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; getMaximum(<span class="keywordtype">void</span>)
<a name="l00174"></a>00174         { 
<a name="l00175"></a>00175             <span class="keywordflow">return</span> mMaximum;
<a name="l00176"></a>00176         }
<a name="l00177"></a>00177 
<a name="l00178"></a>00178 
<a name="l00181"></a><a class="code" href="classOgre_1_1AxisAlignedBox.html#ace4bd8141eb4f5984e52a6cb31e7a571">00181</a>         <span class="keyword">inline</span> <span class="keywordtype">void</span> setMinimum( <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; vec )
<a name="l00182"></a>00182         {
<a name="l00183"></a>00183             mExtent = EXTENT_FINITE;
<a name="l00184"></a>00184             mMinimum = vec;
<a name="l00185"></a>00185         }
<a name="l00186"></a>00186 
<a name="l00187"></a><a class="code" href="classOgre_1_1AxisAlignedBox.html#aebb44ed507a75cdfbc4bc0fff365ffc7">00187</a>         <span class="keyword">inline</span> <span class="keywordtype">void</span> setMinimum( <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> x, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> y, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> z )
<a name="l00188"></a>00188         {
<a name="l00189"></a>00189             mExtent = EXTENT_FINITE;
<a name="l00190"></a>00190             mMinimum.<a class="code" href="classOgre_1_1Vector3.html#a27be092ad0b7e0504ddf4db5cd565f14">x</a> = x;
<a name="l00191"></a>00191             mMinimum.y = y;
<a name="l00192"></a>00192             mMinimum.z = z;
<a name="l00193"></a>00193         }
<a name="l00194"></a>00194 
<a name="l00198"></a><a class="code" href="classOgre_1_1AxisAlignedBox.html#a3142685d30334a229535ae5265d65dd0">00198</a>         <span class="keyword">inline</span> <span class="keywordtype">void</span> setMinimumX(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> x)
<a name="l00199"></a>00199         {
<a name="l00200"></a>00200             mMinimum.x = x;
<a name="l00201"></a>00201         }
<a name="l00202"></a>00202 
<a name="l00203"></a><a class="code" href="classOgre_1_1AxisAlignedBox.html#ae3870fdd15eec672cbb31a72243b9099">00203</a>         <span class="keyword">inline</span> <span class="keywordtype">void</span> setMinimumY(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> y)
<a name="l00204"></a>00204         {
<a name="l00205"></a>00205             mMinimum.y = y;
<a name="l00206"></a>00206         }
<a name="l00207"></a>00207 
<a name="l00208"></a><a class="code" href="classOgre_1_1AxisAlignedBox.html#a18b7996a011d896e1e2065acce0bac67">00208</a>         <span class="keyword">inline</span> <span class="keywordtype">void</span> setMinimumZ(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> z)
<a name="l00209"></a>00209         {
<a name="l00210"></a>00210             mMinimum.z = z;
<a name="l00211"></a>00211         }
<a name="l00212"></a>00212 
<a name="l00215"></a><a class="code" href="classOgre_1_1AxisAlignedBox.html#a76ad2dc729fbee83db77e0fa1eb101ed">00215</a>         <span class="keyword">inline</span> <span class="keywordtype">void</span> setMaximum( <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; vec )
<a name="l00216"></a>00216         {
<a name="l00217"></a>00217             mExtent = EXTENT_FINITE;
<a name="l00218"></a>00218             mMaximum = vec;
<a name="l00219"></a>00219         }
<a name="l00220"></a>00220 
<a name="l00221"></a><a class="code" href="classOgre_1_1AxisAlignedBox.html#ae61ad12fad9545d49554ac6fcb9da224">00221</a>         <span class="keyword">inline</span> <span class="keywordtype">void</span> setMaximum( <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> x, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> y, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> z )
<a name="l00222"></a>00222         {
<a name="l00223"></a>00223             mExtent = EXTENT_FINITE;
<a name="l00224"></a>00224             mMaximum.<a class="code" href="classOgre_1_1Vector3.html#a27be092ad0b7e0504ddf4db5cd565f14">x</a> = x;
<a name="l00225"></a>00225             mMaximum.y = y;
<a name="l00226"></a>00226             mMaximum.z = z;
<a name="l00227"></a>00227         }
<a name="l00228"></a>00228 
<a name="l00232"></a><a class="code" href="classOgre_1_1AxisAlignedBox.html#a283c031dbabc054cde094b97d1a9e7dc">00232</a>         <span class="keyword">inline</span> <span class="keywordtype">void</span> setMaximumX( <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> x )
<a name="l00233"></a>00233         {
<a name="l00234"></a>00234             mMaximum.x = x;
<a name="l00235"></a>00235         }
<a name="l00236"></a>00236 
<a name="l00237"></a><a class="code" href="classOgre_1_1AxisAlignedBox.html#ab8f460db81d836e4b898e9f326c324d0">00237</a>         <span class="keyword">inline</span> <span class="keywordtype">void</span> setMaximumY( <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> y )
<a name="l00238"></a>00238         {
<a name="l00239"></a>00239             mMaximum.y = y;
<a name="l00240"></a>00240         }
<a name="l00241"></a>00241 
<a name="l00242"></a><a class="code" href="classOgre_1_1AxisAlignedBox.html#a7707872f77222c8eef359b4b7e14c2e5">00242</a>         <span class="keyword">inline</span> <span class="keywordtype">void</span> setMaximumZ( <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> z )
<a name="l00243"></a>00243         {
<a name="l00244"></a>00244             mMaximum.z = z;
<a name="l00245"></a>00245         }
<a name="l00246"></a>00246 
<a name="l00249"></a><a class="code" href="classOgre_1_1AxisAlignedBox.html#a6de5f05eea95ab39fe83349238e210c5">00249</a>         <span class="keyword">inline</span> <span class="keywordtype">void</span> setExtents( <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; min, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; max )
<a name="l00250"></a>00250         {
<a name="l00251"></a>00251             assert( (min.<a class="code" href="classOgre_1_1Vector3.html#a27be092ad0b7e0504ddf4db5cd565f14">x</a> &lt;= max.<a class="code" href="classOgre_1_1Vector3.html#a27be092ad0b7e0504ddf4db5cd565f14">x</a> &amp;&amp; min.<a class="code" href="classOgre_1_1Vector3.html#a05ca4492ce30a049ae4102e3f5e85aff">y</a> &lt;= max.<a class="code" href="classOgre_1_1Vector3.html#a05ca4492ce30a049ae4102e3f5e85aff">y</a> &amp;&amp; min.<a class="code" href="classOgre_1_1Vector3.html#ab1f9e7702256f32156be4d7e0fdafd7e">z</a> &lt;= max.<a class="code" href="classOgre_1_1Vector3.html#ab1f9e7702256f32156be4d7e0fdafd7e">z</a>) &amp;&amp;
<a name="l00252"></a>00252                 <span class="stringliteral">&quot;The minimum corner of the box must be less than or equal to maximum corner&quot;</span> );
<a name="l00253"></a>00253 
<a name="l00254"></a>00254             mExtent = EXTENT_FINITE;
<a name="l00255"></a>00255             mMinimum = min;
<a name="l00256"></a>00256             mMaximum = max;
<a name="l00257"></a>00257         }
<a name="l00258"></a>00258 
<a name="l00259"></a><a class="code" href="classOgre_1_1AxisAlignedBox.html#a2e0be3251dbe51eec06999a0a9380359">00259</a>         <span class="keyword">inline</span> <span class="keywordtype">void</span> setExtents(
<a name="l00260"></a>00260             <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> mx, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> my, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> mz,
<a name="l00261"></a>00261             <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> Mx, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> My, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> Mz )
<a name="l00262"></a>00262         {
<a name="l00263"></a>00263             assert( (mx &lt;= Mx &amp;&amp; my &lt;= My &amp;&amp; mz &lt;= Mz) &amp;&amp;
<a name="l00264"></a>00264                 <span class="stringliteral">&quot;The minimum corner of the box must be less than or equal to maximum corner&quot;</span> );
<a name="l00265"></a>00265 
<a name="l00266"></a>00266             mExtent = EXTENT_FINITE;
<a name="l00267"></a>00267 
<a name="l00268"></a>00268             mMinimum.x = mx;
<a name="l00269"></a>00269             mMinimum.y = my;
<a name="l00270"></a>00270             mMinimum.z = mz;
<a name="l00271"></a>00271 
<a name="l00272"></a>00272             mMaximum.x = Mx;
<a name="l00273"></a>00273             mMaximum.y = My;
<a name="l00274"></a>00274             mMaximum.z = Mz;
<a name="l00275"></a>00275 
<a name="l00276"></a>00276         }
<a name="l00277"></a>00277 
<a name="l00302"></a><a class="code" href="classOgre_1_1AxisAlignedBox.html#ab749779f8ed309a24cedf9a1c0ceebc7">00302</a>         <span class="keyword">inline</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>* getAllCorners(<span class="keywordtype">void</span>)<span class="keyword"> const</span>
<a name="l00303"></a>00303 <span class="keyword">        </span>{
<a name="l00304"></a>00304             assert( (mExtent == EXTENT_FINITE) &amp;&amp; <span class="stringliteral">&quot;Can&#39;t get corners of a null or infinite AAB&quot;</span> );
<a name="l00305"></a>00305 
<a name="l00306"></a>00306             <span class="comment">// The order of these items is, using right-handed co-ordinates:</span>
<a name="l00307"></a>00307             <span class="comment">// Minimum Z face, starting with Min(all), then anticlockwise</span>
<a name="l00308"></a>00308             <span class="comment">//   around face (looking onto the face)</span>
<a name="l00309"></a>00309             <span class="comment">// Maximum Z face, starting with Max(all), then anticlockwise</span>
<a name="l00310"></a>00310             <span class="comment">//   around face (looking onto the face)</span>
<a name="l00311"></a>00311             <span class="comment">// Only for optimization/compatibility.</span>
<a name="l00312"></a>00312             <span class="keywordflow">if</span> (!mCorners)
<a name="l00313"></a>00313                 mCorners = <a class="code" href="group__Memory.html#ga3211e4a6a806aa789b38dce2432ef472" title="Allocate a block of memory for a primitive type, and indicate the category of usage.">OGRE_ALLOC_T</a>(<a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>, 8, <a class="code" href="group__Memory.html#gga830fab51be174d6f2849857cb1abb36aa8a55fa0fcaa8403bb51ca210f882ed90" title="Nodes, control data.">MEMCATEGORY_SCENE_CONTROL</a>);
<a name="l00314"></a>00314 
<a name="l00315"></a>00315             mCorners[0] = mMinimum;
<a name="l00316"></a>00316             mCorners[1].x = mMinimum.x; mCorners[1].y = mMaximum.y; mCorners[1].z = mMinimum.z;
<a name="l00317"></a>00317             mCorners[2].x = mMaximum.x; mCorners[2].y = mMaximum.y; mCorners[2].z = mMinimum.z;
<a name="l00318"></a>00318             mCorners[3].x = mMaximum.x; mCorners[3].y = mMinimum.y; mCorners[3].z = mMinimum.z;            
<a name="l00319"></a>00319 
<a name="l00320"></a>00320             mCorners[4] = mMaximum;
<a name="l00321"></a>00321             mCorners[5].x = mMinimum.x; mCorners[5].y = mMaximum.y; mCorners[5].z = mMaximum.z;
<a name="l00322"></a>00322             mCorners[6].x = mMinimum.x; mCorners[6].y = mMinimum.y; mCorners[6].z = mMaximum.z;
<a name="l00323"></a>00323             mCorners[7].x = mMaximum.x; mCorners[7].y = mMinimum.y; mCorners[7].z = mMaximum.z;
<a name="l00324"></a>00324 
<a name="l00325"></a>00325             <span class="keywordflow">return</span> mCorners;
<a name="l00326"></a>00326         }
<a name="l00327"></a>00327 
<a name="l00330"></a><a class="code" href="classOgre_1_1AxisAlignedBox.html#a71b9c846c5698948e0fd57d9f6e05461">00330</a>         <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> getCorner(<a class="code" href="classOgre_1_1AxisAlignedBox.html#a771c83dfb946e6d66c9ddf09fba7e5b3">CornerEnum</a> cornerToGet)<span class="keyword"> const</span>
<a name="l00331"></a>00331 <span class="keyword">        </span>{
<a name="l00332"></a>00332             <span class="keywordflow">switch</span>(cornerToGet)
<a name="l00333"></a>00333             {
<a name="l00334"></a>00334             <span class="keywordflow">case</span> FAR_LEFT_BOTTOM:
<a name="l00335"></a>00335                 <span class="keywordflow">return</span> mMinimum;
<a name="l00336"></a>00336             <span class="keywordflow">case</span> FAR_LEFT_TOP:
<a name="l00337"></a>00337                 <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>(mMinimum.x, mMaximum.y, mMinimum.z);
<a name="l00338"></a>00338             <span class="keywordflow">case</span> FAR_RIGHT_TOP:
<a name="l00339"></a>00339                 <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>(mMaximum.x, mMaximum.y, mMinimum.z);
<a name="l00340"></a>00340             <span class="keywordflow">case</span> FAR_RIGHT_BOTTOM:
<a name="l00341"></a>00341                 <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>(mMaximum.x, mMinimum.y, mMinimum.z);
<a name="l00342"></a>00342             <span class="keywordflow">case</span> NEAR_RIGHT_BOTTOM:
<a name="l00343"></a>00343                 <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>(mMaximum.x, mMinimum.y, mMaximum.z);
<a name="l00344"></a>00344             <span class="keywordflow">case</span> NEAR_LEFT_BOTTOM:
<a name="l00345"></a>00345                 <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>(mMinimum.x, mMinimum.y, mMaximum.z);
<a name="l00346"></a>00346             <span class="keywordflow">case</span> NEAR_LEFT_TOP:
<a name="l00347"></a>00347                 <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>(mMinimum.x, mMaximum.y, mMaximum.z);
<a name="l00348"></a>00348             <span class="keywordflow">case</span> NEAR_RIGHT_TOP:
<a name="l00349"></a>00349                 <span class="keywordflow">return</span> mMaximum;
<a name="l00350"></a>00350             <span class="keywordflow">default</span>:
<a name="l00351"></a>00351                 <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>();
<a name="l00352"></a>00352             }
<a name="l00353"></a>00353         }
<a name="l00354"></a>00354 
<a name="l00355"></a><a class="code" href="classOgre_1_1AxisAlignedBox.html#acc52ead7fb1c559d3fa2f8573a225feb">00355</a>         <a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <span class="keyword">friend</span> std::ostream&amp; <a class="code" href="group__General.html#ga6d67d46d838de3b38264f17fb792cddc">operator&lt;&lt;</a>( std::ostream&amp; o, <span class="keyword">const</span> <a class="code" href="classOgre_1_1AxisAlignedBox.html" title="A 3D box aligned with the x/y/z axes.">AxisAlignedBox</a> aab )
<a name="l00356"></a>00356         {
<a name="l00357"></a>00357             <span class="keywordflow">switch</span> (aab.<a class="code" href="classOgre_1_1AxisAlignedBox.html#a756e8324082dc0b9f1d7926847711ef4">mExtent</a>)
<a name="l00358"></a>00358             {
<a name="l00359"></a>00359             <span class="keywordflow">case</span> EXTENT_NULL:
<a name="l00360"></a>00360                 o &lt;&lt; <span class="stringliteral">&quot;AxisAlignedBox(null)&quot;</span>;
<a name="l00361"></a>00361                 <span class="keywordflow">return</span> o;
<a name="l00362"></a>00362 
<a name="l00363"></a>00363             <span class="keywordflow">case</span> EXTENT_FINITE:
<a name="l00364"></a>00364                 o &lt;&lt; <span class="stringliteral">&quot;AxisAlignedBox(min=&quot;</span> &lt;&lt; aab.<a class="code" href="classOgre_1_1AxisAlignedBox.html#a958c03c0afd2eef4347d345bea8c94a5">mMinimum</a> &lt;&lt; <span class="stringliteral">&quot;, max=&quot;</span> &lt;&lt; aab.<a class="code" href="classOgre_1_1AxisAlignedBox.html#a2254e8ef682cda1a96693637742c9834">mMaximum</a> &lt;&lt; <span class="stringliteral">&quot;)&quot;</span>;
<a name="l00365"></a>00365                 <span class="keywordflow">return</span> o;
<a name="l00366"></a>00366 
<a name="l00367"></a>00367             <span class="keywordflow">case</span> EXTENT_INFINITE:
<a name="l00368"></a>00368                 o &lt;&lt; <span class="stringliteral">&quot;AxisAlignedBox(infinite)&quot;</span>;
<a name="l00369"></a>00369                 <span class="keywordflow">return</span> o;
<a name="l00370"></a>00370 
<a name="l00371"></a>00371             <span class="keywordflow">default</span>: <span class="comment">// shut up compiler</span>
<a name="l00372"></a>00372                 assert( <span class="keyword">false</span> &amp;&amp; <span class="stringliteral">&quot;Never reached&quot;</span> );
<a name="l00373"></a>00373                 <span class="keywordflow">return</span> o;
<a name="l00374"></a>00374             }
<a name="l00375"></a>00375         }
<a name="l00376"></a>00376 
<a name="l00380"></a><a class="code" href="classOgre_1_1AxisAlignedBox.html#a569d00c84979da765abfc66a64b25b68">00380</a>         <span class="keywordtype">void</span> merge( <span class="keyword">const</span> <a class="code" href="classOgre_1_1AxisAlignedBox.html" title="A 3D box aligned with the x/y/z axes.">AxisAlignedBox</a>&amp; rhs )
<a name="l00381"></a>00381         {
<a name="l00382"></a>00382             <span class="comment">// Do nothing if rhs null, or this is infinite</span>
<a name="l00383"></a>00383             <span class="keywordflow">if</span> ((rhs.<a class="code" href="classOgre_1_1AxisAlignedBox.html#a756e8324082dc0b9f1d7926847711ef4">mExtent</a> == EXTENT_NULL) || (mExtent == EXTENT_INFINITE))
<a name="l00384"></a>00384             {
<a name="l00385"></a>00385                 <span class="keywordflow">return</span>;
<a name="l00386"></a>00386             }
<a name="l00387"></a>00387             <span class="comment">// Otherwise if rhs is infinite, make this infinite, too</span>
<a name="l00388"></a>00388             <span class="keywordflow">else</span> <span class="keywordflow">if</span> (rhs.<a class="code" href="classOgre_1_1AxisAlignedBox.html#a756e8324082dc0b9f1d7926847711ef4">mExtent</a> == EXTENT_INFINITE)
<a name="l00389"></a>00389             {
<a name="l00390"></a>00390                 mExtent = EXTENT_INFINITE;
<a name="l00391"></a>00391             }
<a name="l00392"></a>00392             <span class="comment">// Otherwise if current null, just take rhs</span>
<a name="l00393"></a>00393             <span class="keywordflow">else</span> <span class="keywordflow">if</span> (mExtent == EXTENT_NULL)
<a name="l00394"></a>00394             {
<a name="l00395"></a>00395                 setExtents(rhs.<a class="code" href="classOgre_1_1AxisAlignedBox.html#a958c03c0afd2eef4347d345bea8c94a5">mMinimum</a>, rhs.<a class="code" href="classOgre_1_1AxisAlignedBox.html#a2254e8ef682cda1a96693637742c9834">mMaximum</a>);
<a name="l00396"></a>00396             }
<a name="l00397"></a>00397             <span class="comment">// Otherwise merge</span>
<a name="l00398"></a>00398             <span class="keywordflow">else</span>
<a name="l00399"></a>00399             {
<a name="l00400"></a>00400                 <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> min = mMinimum;
<a name="l00401"></a>00401                 <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> max = mMaximum;
<a name="l00402"></a>00402                 max.<a class="code" href="classOgre_1_1Vector3.html#a61e91dcf16f7db52d299e976526218e3" title="Sets this vector&#39;s components to the maximum of its own and the ones of the passed in vector...">makeCeil</a>(rhs.<a class="code" href="classOgre_1_1AxisAlignedBox.html#a2254e8ef682cda1a96693637742c9834">mMaximum</a>);
<a name="l00403"></a>00403                 min.<a class="code" href="classOgre_1_1Vector3.html#a8430bb9f7756acb8256497f004afac49" title="Sets this vector&#39;s components to the minimum of its own and the ones of the passed in vector...">makeFloor</a>(rhs.<a class="code" href="classOgre_1_1AxisAlignedBox.html#a958c03c0afd2eef4347d345bea8c94a5">mMinimum</a>);
<a name="l00404"></a>00404 
<a name="l00405"></a>00405                 setExtents(min, max);
<a name="l00406"></a>00406             }
<a name="l00407"></a>00407 
<a name="l00408"></a>00408         }
<a name="l00409"></a>00409 
<a name="l00412"></a><a class="code" href="classOgre_1_1AxisAlignedBox.html#af3ad8fdc676dc194817f6b7699914d5d">00412</a>         <span class="keyword">inline</span> <span class="keywordtype">void</span> merge( <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; point )
<a name="l00413"></a>00413         {
<a name="l00414"></a>00414             <span class="keywordflow">switch</span> (mExtent)
<a name="l00415"></a>00415             {
<a name="l00416"></a>00416             <span class="keywordflow">case</span> EXTENT_NULL: <span class="comment">// if null, use this point</span>
<a name="l00417"></a>00417                 setExtents(point, point);
<a name="l00418"></a>00418                 <span class="keywordflow">return</span>;
<a name="l00419"></a>00419 
<a name="l00420"></a>00420             <span class="keywordflow">case</span> EXTENT_FINITE:
<a name="l00421"></a>00421                 mMaximum.makeCeil(point);
<a name="l00422"></a>00422                 mMinimum.makeFloor(point);
<a name="l00423"></a>00423                 <span class="keywordflow">return</span>;
<a name="l00424"></a>00424 
<a name="l00425"></a>00425             <span class="keywordflow">case</span> EXTENT_INFINITE: <span class="comment">// if infinite, makes no difference</span>
<a name="l00426"></a>00426                 <span class="keywordflow">return</span>;
<a name="l00427"></a>00427             }
<a name="l00428"></a>00428 
<a name="l00429"></a>00429             assert( <span class="keyword">false</span> &amp;&amp; <span class="stringliteral">&quot;Never reached&quot;</span> );
<a name="l00430"></a>00430         }
<a name="l00431"></a>00431 
<a name="l00441"></a><a class="code" href="classOgre_1_1AxisAlignedBox.html#ae2e7a8dc14154120b288aabd468fe9d3">00441</a>         <span class="keyword">inline</span> <span class="keywordtype">void</span> transform( <span class="keyword">const</span> <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a>&amp; matrix )
<a name="l00442"></a>00442         {
<a name="l00443"></a>00443             <span class="comment">// Do nothing if current null or infinite</span>
<a name="l00444"></a>00444             <span class="keywordflow">if</span>( mExtent != EXTENT_FINITE )
<a name="l00445"></a>00445                 <span class="keywordflow">return</span>;
<a name="l00446"></a>00446 
<a name="l00447"></a>00447             <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> oldMin, oldMax, currentCorner;
<a name="l00448"></a>00448 
<a name="l00449"></a>00449             <span class="comment">// Getting the old values so that we can use the existing merge method.</span>
<a name="l00450"></a>00450             oldMin = mMinimum;
<a name="l00451"></a>00451             oldMax = mMaximum;
<a name="l00452"></a>00452 
<a name="l00453"></a>00453             <span class="comment">// reset</span>
<a name="l00454"></a>00454             setNull();
<a name="l00455"></a>00455 
<a name="l00456"></a>00456             <span class="comment">// We sequentially compute the corners in the following order :</span>
<a name="l00457"></a>00457             <span class="comment">// 0, 6, 5, 1, 2, 4 ,7 , 3</span>
<a name="l00458"></a>00458             <span class="comment">// This sequence allows us to only change one member at a time to get at all corners.</span>
<a name="l00459"></a>00459 
<a name="l00460"></a>00460             <span class="comment">// For each one, we transform it using the matrix</span>
<a name="l00461"></a>00461             <span class="comment">// Which gives the resulting point and merge the resulting point.</span>
<a name="l00462"></a>00462 
<a name="l00463"></a>00463             <span class="comment">// First corner </span>
<a name="l00464"></a>00464             <span class="comment">// min min min</span>
<a name="l00465"></a>00465             currentCorner = oldMin;
<a name="l00466"></a>00466             merge( matrix * currentCorner );
<a name="l00467"></a>00467 
<a name="l00468"></a>00468             <span class="comment">// min,min,max</span>
<a name="l00469"></a>00469             currentCorner.z = oldMax.<a class="code" href="classOgre_1_1Vector3.html#ab1f9e7702256f32156be4d7e0fdafd7e">z</a>;
<a name="l00470"></a>00470             merge( matrix * currentCorner );
<a name="l00471"></a>00471 
<a name="l00472"></a>00472             <span class="comment">// min max max</span>
<a name="l00473"></a>00473             currentCorner.y = oldMax.<a class="code" href="classOgre_1_1Vector3.html#a05ca4492ce30a049ae4102e3f5e85aff">y</a>;
<a name="l00474"></a>00474             merge( matrix * currentCorner );
<a name="l00475"></a>00475 
<a name="l00476"></a>00476             <span class="comment">// min max min</span>
<a name="l00477"></a>00477             currentCorner.z = oldMin.<a class="code" href="classOgre_1_1Vector3.html#ab1f9e7702256f32156be4d7e0fdafd7e">z</a>;
<a name="l00478"></a>00478             merge( matrix * currentCorner );
<a name="l00479"></a>00479 
<a name="l00480"></a>00480             <span class="comment">// max max min</span>
<a name="l00481"></a>00481             currentCorner.x = oldMax.<a class="code" href="classOgre_1_1Vector3.html#a27be092ad0b7e0504ddf4db5cd565f14">x</a>;
<a name="l00482"></a>00482             merge( matrix * currentCorner );
<a name="l00483"></a>00483 
<a name="l00484"></a>00484             <span class="comment">// max max max</span>
<a name="l00485"></a>00485             currentCorner.z = oldMax.<a class="code" href="classOgre_1_1Vector3.html#ab1f9e7702256f32156be4d7e0fdafd7e">z</a>;
<a name="l00486"></a>00486             merge( matrix * currentCorner );
<a name="l00487"></a>00487 
<a name="l00488"></a>00488             <span class="comment">// max min max</span>
<a name="l00489"></a>00489             currentCorner.y = oldMin.<a class="code" href="classOgre_1_1Vector3.html#a05ca4492ce30a049ae4102e3f5e85aff">y</a>;
<a name="l00490"></a>00490             merge( matrix * currentCorner );
<a name="l00491"></a>00491 
<a name="l00492"></a>00492             <span class="comment">// max min min</span>
<a name="l00493"></a>00493             currentCorner.z = oldMin.<a class="code" href="classOgre_1_1Vector3.html#ab1f9e7702256f32156be4d7e0fdafd7e">z</a>;
<a name="l00494"></a>00494             merge( matrix * currentCorner ); 
<a name="l00495"></a>00495         }
<a name="l00496"></a>00496 
<a name="l00508"></a><a class="code" href="classOgre_1_1AxisAlignedBox.html#a08597ff0f683fd94d23632dc749bef55">00508</a>         <span class="keywordtype">void</span> transformAffine(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a>&amp; m)
<a name="l00509"></a>00509         {
<a name="l00510"></a>00510             assert(m.<a class="code" href="classOgre_1_1Matrix4.html#a582b20b912ed7d7f8f179505dfbe7a4e" title="Check whether or not the matrix is affine matrix.">isAffine</a>());
<a name="l00511"></a>00511 
<a name="l00512"></a>00512             <span class="comment">// Do nothing if current null or infinite</span>
<a name="l00513"></a>00513             <span class="keywordflow">if</span> ( mExtent != EXTENT_FINITE )
<a name="l00514"></a>00514                 <span class="keywordflow">return</span>;
<a name="l00515"></a>00515 
<a name="l00516"></a>00516             <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> centre = getCenter();
<a name="l00517"></a>00517             <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> halfSize = getHalfSize();
<a name="l00518"></a>00518 
<a name="l00519"></a>00519             <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> newCentre = m.<a class="code" href="classOgre_1_1Matrix4.html#afcd6dae51beb8283338ad52ac63c86fb" title="3-D Vector transformation specially for an affine matrix.">transformAffine</a>(centre);
<a name="l00520"></a>00520             <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> newHalfSize(
<a name="l00521"></a>00521                 <a class="code" href="classOgre_1_1Math.html#ae9e2434f05aed3c19b600af6b48c59b7" title="Absolute value function.">Math::Abs</a>(m[0][0]) * halfSize.<a class="code" href="classOgre_1_1Vector3.html#a27be092ad0b7e0504ddf4db5cd565f14">x</a> + <a class="code" href="classOgre_1_1Math.html#ae9e2434f05aed3c19b600af6b48c59b7" title="Absolute value function.">Math::Abs</a>(m[0][1]) * halfSize.<a class="code" href="classOgre_1_1Vector3.html#a05ca4492ce30a049ae4102e3f5e85aff">y</a> + <a class="code" href="classOgre_1_1Math.html#ae9e2434f05aed3c19b600af6b48c59b7" title="Absolute value function.">Math::Abs</a>(m[0][2]) * halfSize.<a class="code" href="classOgre_1_1Vector3.html#ab1f9e7702256f32156be4d7e0fdafd7e">z</a>, 
<a name="l00522"></a>00522                 <a class="code" href="classOgre_1_1Math.html#ae9e2434f05aed3c19b600af6b48c59b7" title="Absolute value function.">Math::Abs</a>(m[1][0]) * halfSize.<a class="code" href="classOgre_1_1Vector3.html#a27be092ad0b7e0504ddf4db5cd565f14">x</a> + <a class="code" href="classOgre_1_1Math.html#ae9e2434f05aed3c19b600af6b48c59b7" title="Absolute value function.">Math::Abs</a>(m[1][1]) * halfSize.<a class="code" href="classOgre_1_1Vector3.html#a05ca4492ce30a049ae4102e3f5e85aff">y</a> + <a class="code" href="classOgre_1_1Math.html#ae9e2434f05aed3c19b600af6b48c59b7" title="Absolute value function.">Math::Abs</a>(m[1][2]) * halfSize.<a class="code" href="classOgre_1_1Vector3.html#ab1f9e7702256f32156be4d7e0fdafd7e">z</a>,
<a name="l00523"></a>00523                 <a class="code" href="classOgre_1_1Math.html#ae9e2434f05aed3c19b600af6b48c59b7" title="Absolute value function.">Math::Abs</a>(m[2][0]) * halfSize.<a class="code" href="classOgre_1_1Vector3.html#a27be092ad0b7e0504ddf4db5cd565f14">x</a> + <a class="code" href="classOgre_1_1Math.html#ae9e2434f05aed3c19b600af6b48c59b7" title="Absolute value function.">Math::Abs</a>(m[2][1]) * halfSize.<a class="code" href="classOgre_1_1Vector3.html#a05ca4492ce30a049ae4102e3f5e85aff">y</a> + <a class="code" href="classOgre_1_1Math.html#ae9e2434f05aed3c19b600af6b48c59b7" title="Absolute value function.">Math::Abs</a>(m[2][2]) * halfSize.<a class="code" href="classOgre_1_1Vector3.html#ab1f9e7702256f32156be4d7e0fdafd7e">z</a>);
<a name="l00524"></a>00524 
<a name="l00525"></a>00525             setExtents(newCentre - newHalfSize, newCentre + newHalfSize);
<a name="l00526"></a>00526         }
<a name="l00527"></a>00527 
<a name="l00530"></a><a class="code" href="classOgre_1_1AxisAlignedBox.html#aa7428e161d37a9715501c678d919eb2a">00530</a>         <span class="keyword">inline</span> <span class="keywordtype">void</span> setNull()
<a name="l00531"></a>00531         {
<a name="l00532"></a>00532             mExtent = EXTENT_NULL;
<a name="l00533"></a>00533         }
<a name="l00534"></a>00534 
<a name="l00537"></a><a class="code" href="classOgre_1_1AxisAlignedBox.html#abeef4ea1111a90001287734529288749">00537</a>         <span class="keyword">inline</span> <span class="keywordtype">bool</span> isNull(<span class="keywordtype">void</span>)<span class="keyword"> const</span>
<a name="l00538"></a>00538 <span class="keyword">        </span>{
<a name="l00539"></a>00539             <span class="keywordflow">return</span> (mExtent == EXTENT_NULL);
<a name="l00540"></a>00540         }
<a name="l00541"></a>00541 
<a name="l00544"></a><a class="code" href="classOgre_1_1AxisAlignedBox.html#a953952743ef5dfd51e2012a11801bb47">00544</a>         <span class="keywordtype">bool</span> isFinite(<span class="keywordtype">void</span>)<span class="keyword"> const</span>
<a name="l00545"></a>00545 <span class="keyword">        </span>{
<a name="l00546"></a>00546             <span class="keywordflow">return</span> (mExtent == EXTENT_FINITE);
<a name="l00547"></a>00547         }
<a name="l00548"></a>00548 
<a name="l00551"></a><a class="code" href="classOgre_1_1AxisAlignedBox.html#a1d02be8fab444a465b52795175fe52dc">00551</a>         <span class="keyword">inline</span> <span class="keywordtype">void</span> setInfinite()
<a name="l00552"></a>00552         {
<a name="l00553"></a>00553             mExtent = EXTENT_INFINITE;
<a name="l00554"></a>00554         }
<a name="l00555"></a>00555 
<a name="l00558"></a><a class="code" href="classOgre_1_1AxisAlignedBox.html#a45665abec389ae0ecbea54a26956a633">00558</a>         <span class="keywordtype">bool</span> isInfinite(<span class="keywordtype">void</span>)<span class="keyword"> const</span>
<a name="l00559"></a>00559 <span class="keyword">        </span>{
<a name="l00560"></a>00560             <span class="keywordflow">return</span> (mExtent == EXTENT_INFINITE);
<a name="l00561"></a>00561         }
<a name="l00562"></a>00562 
<a name="l00564"></a><a class="code" href="classOgre_1_1AxisAlignedBox.html#a7f8715f143dbb147e5854fe160e24a0a">00564</a>         <span class="keyword">inline</span> <span class="keywordtype">bool</span> intersects(<span class="keyword">const</span> <a class="code" href="classOgre_1_1AxisAlignedBox.html" title="A 3D box aligned with the x/y/z axes.">AxisAlignedBox</a>&amp; b2)<span class="keyword"> const</span>
<a name="l00565"></a>00565 <span class="keyword">        </span>{
<a name="l00566"></a>00566             <span class="comment">// Early-fail for nulls</span>
<a name="l00567"></a>00567             <span class="keywordflow">if</span> (this-&gt;isNull() || b2.<a class="code" href="classOgre_1_1AxisAlignedBox.html#abeef4ea1111a90001287734529288749" title="Returns true if the box is null i.e.">isNull</a>())
<a name="l00568"></a>00568                 <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00569"></a>00569 
<a name="l00570"></a>00570             <span class="comment">// Early-success for infinites</span>
<a name="l00571"></a>00571             <span class="keywordflow">if</span> (this-&gt;isInfinite() || b2.<a class="code" href="classOgre_1_1AxisAlignedBox.html#a45665abec389ae0ecbea54a26956a633" title="Returns true if the box is infinite.">isInfinite</a>())
<a name="l00572"></a>00572                 <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00573"></a>00573 
<a name="l00574"></a>00574             <span class="comment">// Use up to 6 separating planes</span>
<a name="l00575"></a>00575             <span class="keywordflow">if</span> (mMaximum.x &lt; b2.<a class="code" href="classOgre_1_1AxisAlignedBox.html#a958c03c0afd2eef4347d345bea8c94a5">mMinimum</a>.<a class="code" href="classOgre_1_1Vector3.html#a27be092ad0b7e0504ddf4db5cd565f14">x</a>)
<a name="l00576"></a>00576                 <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00577"></a>00577             <span class="keywordflow">if</span> (mMaximum.y &lt; b2.<a class="code" href="classOgre_1_1AxisAlignedBox.html#a958c03c0afd2eef4347d345bea8c94a5">mMinimum</a>.<a class="code" href="classOgre_1_1Vector3.html#a05ca4492ce30a049ae4102e3f5e85aff">y</a>)
<a name="l00578"></a>00578                 <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00579"></a>00579             <span class="keywordflow">if</span> (mMaximum.z &lt; b2.<a class="code" href="classOgre_1_1AxisAlignedBox.html#a958c03c0afd2eef4347d345bea8c94a5">mMinimum</a>.<a class="code" href="classOgre_1_1Vector3.html#ab1f9e7702256f32156be4d7e0fdafd7e">z</a>)
<a name="l00580"></a>00580                 <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00581"></a>00581 
<a name="l00582"></a>00582             <span class="keywordflow">if</span> (mMinimum.x &gt; b2.<a class="code" href="classOgre_1_1AxisAlignedBox.html#a2254e8ef682cda1a96693637742c9834">mMaximum</a>.<a class="code" href="classOgre_1_1Vector3.html#a27be092ad0b7e0504ddf4db5cd565f14">x</a>)
<a name="l00583"></a>00583                 <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00584"></a>00584             <span class="keywordflow">if</span> (mMinimum.y &gt; b2.<a class="code" href="classOgre_1_1AxisAlignedBox.html#a2254e8ef682cda1a96693637742c9834">mMaximum</a>.<a class="code" href="classOgre_1_1Vector3.html#a05ca4492ce30a049ae4102e3f5e85aff">y</a>)
<a name="l00585"></a>00585                 <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00586"></a>00586             <span class="keywordflow">if</span> (mMinimum.z &gt; b2.<a class="code" href="classOgre_1_1AxisAlignedBox.html#a2254e8ef682cda1a96693637742c9834">mMaximum</a>.<a class="code" href="classOgre_1_1Vector3.html#ab1f9e7702256f32156be4d7e0fdafd7e">z</a>)
<a name="l00587"></a>00587                 <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00588"></a>00588 
<a name="l00589"></a>00589             <span class="comment">// otherwise, must be intersecting</span>
<a name="l00590"></a>00590             <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00591"></a>00591 
<a name="l00592"></a>00592         }
<a name="l00593"></a>00593 
<a name="l00595"></a><a class="code" href="classOgre_1_1AxisAlignedBox.html#a1bbe1d561652390716416e3970469dc9">00595</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1AxisAlignedBox.html" title="A 3D box aligned with the x/y/z axes.">AxisAlignedBox</a> intersection(<span class="keyword">const</span> <a class="code" href="classOgre_1_1AxisAlignedBox.html" title="A 3D box aligned with the x/y/z axes.">AxisAlignedBox</a>&amp; b2)<span class="keyword"> const</span>
<a name="l00596"></a>00596 <span class="keyword">        </span>{
<a name="l00597"></a>00597             <span class="keywordflow">if</span> (this-&gt;isNull() || b2.<a class="code" href="classOgre_1_1AxisAlignedBox.html#abeef4ea1111a90001287734529288749" title="Returns true if the box is null i.e.">isNull</a>())
<a name="l00598"></a>00598             {
<a name="l00599"></a>00599                 <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1AxisAlignedBox.html" title="A 3D box aligned with the x/y/z axes.">AxisAlignedBox</a>();
<a name="l00600"></a>00600             }
<a name="l00601"></a>00601             <span class="keywordflow">else</span> <span class="keywordflow">if</span> (this-&gt;isInfinite())
<a name="l00602"></a>00602             {
<a name="l00603"></a>00603                 <span class="keywordflow">return</span> b2;
<a name="l00604"></a>00604             }
<a name="l00605"></a>00605             <span class="keywordflow">else</span> <span class="keywordflow">if</span> (b2.<a class="code" href="classOgre_1_1AxisAlignedBox.html#a45665abec389ae0ecbea54a26956a633" title="Returns true if the box is infinite.">isInfinite</a>())
<a name="l00606"></a>00606             {
<a name="l00607"></a>00607                 <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00608"></a>00608             }
<a name="l00609"></a>00609 
<a name="l00610"></a>00610             <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> intMin = mMinimum;
<a name="l00611"></a>00611             <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> intMax = mMaximum;
<a name="l00612"></a>00612 
<a name="l00613"></a>00613             intMin.<a class="code" href="classOgre_1_1Vector3.html#a61e91dcf16f7db52d299e976526218e3" title="Sets this vector&#39;s components to the maximum of its own and the ones of the passed in vector...">makeCeil</a>(b2.<a class="code" href="classOgre_1_1AxisAlignedBox.html#a0ef53ae1514666961bb13fa170162273" title="Gets the minimum corner of the box.">getMinimum</a>());
<a name="l00614"></a>00614             intMax.<a class="code" href="classOgre_1_1Vector3.html#a8430bb9f7756acb8256497f004afac49" title="Sets this vector&#39;s components to the minimum of its own and the ones of the passed in vector...">makeFloor</a>(b2.<a class="code" href="classOgre_1_1AxisAlignedBox.html#a89c67352264aa62ee69283b25dca4982" title="Gets the maximum corner of the box.">getMaximum</a>());
<a name="l00615"></a>00615 
<a name="l00616"></a>00616             <span class="comment">// Check intersection isn&#39;t null</span>
<a name="l00617"></a>00617             <span class="keywordflow">if</span> (intMin.<a class="code" href="classOgre_1_1Vector3.html#a27be092ad0b7e0504ddf4db5cd565f14">x</a> &lt; intMax.<a class="code" href="classOgre_1_1Vector3.html#a27be092ad0b7e0504ddf4db5cd565f14">x</a> &amp;&amp;
<a name="l00618"></a>00618                 intMin.<a class="code" href="classOgre_1_1Vector3.html#a05ca4492ce30a049ae4102e3f5e85aff">y</a> &lt; intMax.<a class="code" href="classOgre_1_1Vector3.html#a05ca4492ce30a049ae4102e3f5e85aff">y</a> &amp;&amp;
<a name="l00619"></a>00619                 intMin.<a class="code" href="classOgre_1_1Vector3.html#ab1f9e7702256f32156be4d7e0fdafd7e">z</a> &lt; intMax.<a class="code" href="classOgre_1_1Vector3.html#ab1f9e7702256f32156be4d7e0fdafd7e">z</a>)
<a name="l00620"></a>00620             {
<a name="l00621"></a>00621                 <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1AxisAlignedBox.html" title="A 3D box aligned with the x/y/z axes.">AxisAlignedBox</a>(intMin, intMax);
<a name="l00622"></a>00622             }
<a name="l00623"></a>00623 
<a name="l00624"></a>00624             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1AxisAlignedBox.html" title="A 3D box aligned with the x/y/z axes.">AxisAlignedBox</a>();
<a name="l00625"></a>00625         }
<a name="l00626"></a>00626 
<a name="l00628"></a><a class="code" href="classOgre_1_1AxisAlignedBox.html#aaa452ad6821e12ea737121b51acf9fe7">00628</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> volume(<span class="keywordtype">void</span>)<span class="keyword"> const</span>
<a name="l00629"></a>00629 <span class="keyword">        </span>{
<a name="l00630"></a>00630             <span class="keywordflow">switch</span> (mExtent)
<a name="l00631"></a>00631             {
<a name="l00632"></a>00632             <span class="keywordflow">case</span> EXTENT_NULL:
<a name="l00633"></a>00633                 <span class="keywordflow">return</span> 0.0f;
<a name="l00634"></a>00634 
<a name="l00635"></a>00635             <span class="keywordflow">case</span> EXTENT_FINITE:
<a name="l00636"></a>00636                 {
<a name="l00637"></a>00637                     <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> diff = mMaximum - mMinimum;
<a name="l00638"></a>00638                     <span class="keywordflow">return</span> diff.<a class="code" href="classOgre_1_1Vector3.html#a27be092ad0b7e0504ddf4db5cd565f14">x</a> * diff.<a class="code" href="classOgre_1_1Vector3.html#a05ca4492ce30a049ae4102e3f5e85aff">y</a> * diff.<a class="code" href="classOgre_1_1Vector3.html#ab1f9e7702256f32156be4d7e0fdafd7e">z</a>;
<a name="l00639"></a>00639                 }
<a name="l00640"></a>00640 
<a name="l00641"></a>00641             <span class="keywordflow">case</span> EXTENT_INFINITE:
<a name="l00642"></a>00642                 <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Math.html#a96373da6032ed7c1ff668430f89393a6">Math::POS_INFINITY</a>;
<a name="l00643"></a>00643 
<a name="l00644"></a>00644             <span class="keywordflow">default</span>: <span class="comment">// shut up compiler</span>
<a name="l00645"></a>00645                 assert( <span class="keyword">false</span> &amp;&amp; <span class="stringliteral">&quot;Never reached&quot;</span> );
<a name="l00646"></a>00646                 <span class="keywordflow">return</span> 0.0f;
<a name="l00647"></a>00647             }
<a name="l00648"></a>00648         }
<a name="l00649"></a>00649 
<a name="l00651"></a><a class="code" href="classOgre_1_1AxisAlignedBox.html#ad77340197d2e06137e82cbae79c895ee">00651</a>         <span class="keyword">inline</span> <span class="keywordtype">void</span> scale(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; s)
<a name="l00652"></a>00652         {
<a name="l00653"></a>00653             <span class="comment">// Do nothing if current null or infinite</span>
<a name="l00654"></a>00654             <span class="keywordflow">if</span> (mExtent != EXTENT_FINITE)
<a name="l00655"></a>00655                 <span class="keywordflow">return</span>;
<a name="l00656"></a>00656 
<a name="l00657"></a>00657             <span class="comment">// NB assumes centered on origin</span>
<a name="l00658"></a>00658             <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> min = mMinimum * s;
<a name="l00659"></a>00659             <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> max = mMaximum * s;
<a name="l00660"></a>00660             setExtents(min, max);
<a name="l00661"></a>00661         }
<a name="l00662"></a>00662 
<a name="l00664"></a><a class="code" href="classOgre_1_1AxisAlignedBox.html#ac8739a02ac7dca031e99bd6c3b582d4f">00664</a>         <span class="keywordtype">bool</span> intersects(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Sphere.html" title="A sphere primitive, mostly used for bounds checking.">Sphere</a>&amp; s)<span class="keyword"> const</span>
<a name="l00665"></a>00665 <span class="keyword">        </span>{
<a name="l00666"></a>00666             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Math.html#a11664bfebecca73dbb42c0959d3d9ff7" title="Ray / plane intersection, returns boolean result and distance.">Math::intersects</a>(s, *<span class="keyword">this</span>); 
<a name="l00667"></a>00667         }
<a name="l00669"></a><a class="code" href="classOgre_1_1AxisAlignedBox.html#ac0c4f8ffe845434ff3c62faa884adcf2">00669</a>         <span class="keywordtype">bool</span> intersects(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Plane.html" title="Defines a plane in 3D space.">Plane</a>&amp; p)<span class="keyword"> const</span>
<a name="l00670"></a>00670 <span class="keyword">        </span>{
<a name="l00671"></a>00671             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Math.html#a11664bfebecca73dbb42c0959d3d9ff7" title="Ray / plane intersection, returns boolean result and distance.">Math::intersects</a>(p, *<span class="keyword">this</span>);
<a name="l00672"></a>00672         }
<a name="l00674"></a><a class="code" href="classOgre_1_1AxisAlignedBox.html#af07e5cb7e3c20ed00c74d1a0c0666bdc">00674</a>         <span class="keywordtype">bool</span> intersects(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; v)<span class="keyword"> const</span>
<a name="l00675"></a>00675 <span class="keyword">        </span>{
<a name="l00676"></a>00676             <span class="keywordflow">switch</span> (mExtent)
<a name="l00677"></a>00677             {
<a name="l00678"></a>00678             <span class="keywordflow">case</span> EXTENT_NULL:
<a name="l00679"></a>00679                 <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00680"></a>00680 
<a name="l00681"></a>00681             <span class="keywordflow">case</span> EXTENT_FINITE:
<a name="l00682"></a>00682                 <span class="keywordflow">return</span>(v.<a class="code" href="classOgre_1_1Vector3.html#a27be092ad0b7e0504ddf4db5cd565f14">x</a> &gt;= mMinimum.x  &amp;&amp;  v.<a class="code" href="classOgre_1_1Vector3.html#a27be092ad0b7e0504ddf4db5cd565f14">x</a> &lt;= mMaximum.x  &amp;&amp; 
<a name="l00683"></a>00683                     v.<a class="code" href="classOgre_1_1Vector3.html#a05ca4492ce30a049ae4102e3f5e85aff">y</a> &gt;= mMinimum.y  &amp;&amp;  v.<a class="code" href="classOgre_1_1Vector3.html#a05ca4492ce30a049ae4102e3f5e85aff">y</a> &lt;= mMaximum.y  &amp;&amp; 
<a name="l00684"></a>00684                     v.<a class="code" href="classOgre_1_1Vector3.html#ab1f9e7702256f32156be4d7e0fdafd7e">z</a> &gt;= mMinimum.z  &amp;&amp;  v.<a class="code" href="classOgre_1_1Vector3.html#ab1f9e7702256f32156be4d7e0fdafd7e">z</a> &lt;= mMaximum.z);
<a name="l00685"></a>00685 
<a name="l00686"></a>00686             <span class="keywordflow">case</span> EXTENT_INFINITE:
<a name="l00687"></a>00687                 <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00688"></a>00688 
<a name="l00689"></a>00689             <span class="keywordflow">default</span>: <span class="comment">// shut up compiler</span>
<a name="l00690"></a>00690                 assert( <span class="keyword">false</span> &amp;&amp; <span class="stringliteral">&quot;Never reached&quot;</span> );
<a name="l00691"></a>00691                 <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00692"></a>00692             }
<a name="l00693"></a>00693         }
<a name="l00695"></a><a class="code" href="classOgre_1_1AxisAlignedBox.html#a7407087b6542b79792d915c60c0b49f0">00695</a>         <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> getCenter(<span class="keywordtype">void</span>)<span class="keyword"> const</span>
<a name="l00696"></a>00696 <span class="keyword">        </span>{
<a name="l00697"></a>00697             assert( (mExtent == EXTENT_FINITE) &amp;&amp; <span class="stringliteral">&quot;Can&#39;t get center of a null or infinite AAB&quot;</span> );
<a name="l00698"></a>00698 
<a name="l00699"></a>00699             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>(
<a name="l00700"></a>00700                 (mMaximum.x + mMinimum.x) * 0.5f,
<a name="l00701"></a>00701                 (mMaximum.y + mMinimum.y) * 0.5f,
<a name="l00702"></a>00702                 (mMaximum.z + mMinimum.z) * 0.5f);
<a name="l00703"></a>00703         }
<a name="l00705"></a><a class="code" href="classOgre_1_1AxisAlignedBox.html#a2618b461f9d78d23d846bd177b21abd0">00705</a>         <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> getSize(<span class="keywordtype">void</span>)<span class="keyword"> const</span>
<a name="l00706"></a>00706 <span class="keyword">        </span>{
<a name="l00707"></a>00707             <span class="keywordflow">switch</span> (mExtent)
<a name="l00708"></a>00708             {
<a name="l00709"></a>00709             <span class="keywordflow">case</span> EXTENT_NULL:
<a name="l00710"></a>00710                 <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Vector3.html#a5da94afc089ec07612b4a2615bb6b86f">Vector3::ZERO</a>;
<a name="l00711"></a>00711 
<a name="l00712"></a>00712             <span class="keywordflow">case</span> EXTENT_FINITE:
<a name="l00713"></a>00713                 <span class="keywordflow">return</span> mMaximum - mMinimum;
<a name="l00714"></a>00714 
<a name="l00715"></a>00715             <span class="keywordflow">case</span> EXTENT_INFINITE:
<a name="l00716"></a>00716                 <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>(
<a name="l00717"></a>00717                     <a class="code" href="classOgre_1_1Math.html#a96373da6032ed7c1ff668430f89393a6">Math::POS_INFINITY</a>,
<a name="l00718"></a>00718                     <a class="code" href="classOgre_1_1Math.html#a96373da6032ed7c1ff668430f89393a6">Math::POS_INFINITY</a>,
<a name="l00719"></a>00719                     <a class="code" href="classOgre_1_1Math.html#a96373da6032ed7c1ff668430f89393a6">Math::POS_INFINITY</a>);
<a name="l00720"></a>00720 
<a name="l00721"></a>00721             <span class="keywordflow">default</span>: <span class="comment">// shut up compiler</span>
<a name="l00722"></a>00722                 assert( <span class="keyword">false</span> &amp;&amp; <span class="stringliteral">&quot;Never reached&quot;</span> );
<a name="l00723"></a>00723                 <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Vector3.html#a5da94afc089ec07612b4a2615bb6b86f">Vector3::ZERO</a>;
<a name="l00724"></a>00724             }
<a name="l00725"></a>00725         }
<a name="l00727"></a><a class="code" href="classOgre_1_1AxisAlignedBox.html#add9cf7a160ec472c91bf0fedb25cfed1">00727</a>         <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> getHalfSize(<span class="keywordtype">void</span>)<span class="keyword"> const</span>
<a name="l00728"></a>00728 <span class="keyword">        </span>{
<a name="l00729"></a>00729             <span class="keywordflow">switch</span> (mExtent)
<a name="l00730"></a>00730             {
<a name="l00731"></a>00731             <span class="keywordflow">case</span> EXTENT_NULL:
<a name="l00732"></a>00732                 <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Vector3.html#a5da94afc089ec07612b4a2615bb6b86f">Vector3::ZERO</a>;
<a name="l00733"></a>00733 
<a name="l00734"></a>00734             <span class="keywordflow">case</span> EXTENT_FINITE:
<a name="l00735"></a>00735                 <span class="keywordflow">return</span> (mMaximum - mMinimum) * 0.5;
<a name="l00736"></a>00736 
<a name="l00737"></a>00737             <span class="keywordflow">case</span> EXTENT_INFINITE:
<a name="l00738"></a>00738                 <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>(
<a name="l00739"></a>00739                     <a class="code" href="classOgre_1_1Math.html#a96373da6032ed7c1ff668430f89393a6">Math::POS_INFINITY</a>,
<a name="l00740"></a>00740                     <a class="code" href="classOgre_1_1Math.html#a96373da6032ed7c1ff668430f89393a6">Math::POS_INFINITY</a>,
<a name="l00741"></a>00741                     <a class="code" href="classOgre_1_1Math.html#a96373da6032ed7c1ff668430f89393a6">Math::POS_INFINITY</a>);
<a name="l00742"></a>00742 
<a name="l00743"></a>00743             <span class="keywordflow">default</span>: <span class="comment">// shut up compiler</span>
<a name="l00744"></a>00744                 assert( <span class="keyword">false</span> &amp;&amp; <span class="stringliteral">&quot;Never reached&quot;</span> );
<a name="l00745"></a>00745                 <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Vector3.html#a5da94afc089ec07612b4a2615bb6b86f">Vector3::ZERO</a>;
<a name="l00746"></a>00746             }
<a name="l00747"></a>00747         }
<a name="l00748"></a>00748 
<a name="l00751"></a><a class="code" href="classOgre_1_1AxisAlignedBox.html#ad3fe7b6013b38cb3710bfa6462328e8b">00751</a>         <span class="keywordtype">bool</span> contains(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; v)<span class="keyword"> const</span>
<a name="l00752"></a>00752 <span class="keyword">        </span>{
<a name="l00753"></a>00753             <span class="keywordflow">if</span> (isNull())
<a name="l00754"></a>00754                 <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00755"></a>00755             <span class="keywordflow">if</span> (isInfinite())
<a name="l00756"></a>00756                 <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00757"></a>00757 
<a name="l00758"></a>00758             <span class="keywordflow">return</span> mMinimum.<a class="code" href="classOgre_1_1Vector3.html#a27be092ad0b7e0504ddf4db5cd565f14">x</a> &lt;= v.<a class="code" href="classOgre_1_1Vector3.html#a27be092ad0b7e0504ddf4db5cd565f14">x</a> &amp;&amp; v.<a class="code" href="classOgre_1_1Vector3.html#a27be092ad0b7e0504ddf4db5cd565f14">x</a> &lt;= mMaximum.x &amp;&amp;
<a name="l00759"></a>00759                    mMinimum.y &lt;= v.<a class="code" href="classOgre_1_1Vector3.html#a05ca4492ce30a049ae4102e3f5e85aff">y</a> &amp;&amp; v.<a class="code" href="classOgre_1_1Vector3.html#a05ca4492ce30a049ae4102e3f5e85aff">y</a> &lt;= mMaximum.y &amp;&amp;
<a name="l00760"></a>00760                    mMinimum.z &lt;= v.<a class="code" href="classOgre_1_1Vector3.html#ab1f9e7702256f32156be4d7e0fdafd7e">z</a> &amp;&amp; v.<a class="code" href="classOgre_1_1Vector3.html#ab1f9e7702256f32156be4d7e0fdafd7e">z</a> &lt;= mMaximum.z;
<a name="l00761"></a>00761         }
<a name="l00762"></a>00762         
<a name="l00764"></a><a class="code" href="classOgre_1_1AxisAlignedBox.html#a565ea7847619be3c9dbf722dcd547ffb">00764</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> distance(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; v)<span class="keyword"> const</span>
<a name="l00765"></a>00765 <span class="keyword">        </span>{
<a name="l00766"></a>00766             
<a name="l00767"></a>00767             <span class="keywordflow">if</span> (this-&gt;contains(v))
<a name="l00768"></a>00768                 <span class="keywordflow">return</span> 0;
<a name="l00769"></a>00769             <span class="keywordflow">else</span>
<a name="l00770"></a>00770             {
<a name="l00771"></a>00771                 <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> maxDist = std::numeric_limits&lt;Real&gt;::min();
<a name="l00772"></a>00772 
<a name="l00773"></a>00773                 <span class="keywordflow">if</span> (v.<a class="code" href="classOgre_1_1Vector3.html#a27be092ad0b7e0504ddf4db5cd565f14">x</a> &lt; mMinimum.x)
<a name="l00774"></a>00774                     maxDist = std::max(maxDist, mMinimum.x - v.<a class="code" href="classOgre_1_1Vector3.html#a27be092ad0b7e0504ddf4db5cd565f14">x</a>);
<a name="l00775"></a>00775                 <span class="keywordflow">if</span> (v.<a class="code" href="classOgre_1_1Vector3.html#a05ca4492ce30a049ae4102e3f5e85aff">y</a> &lt; mMinimum.y)
<a name="l00776"></a>00776                     maxDist = std::max(maxDist, mMinimum.y - v.<a class="code" href="classOgre_1_1Vector3.html#a05ca4492ce30a049ae4102e3f5e85aff">y</a>);
<a name="l00777"></a>00777                 <span class="keywordflow">if</span> (v.<a class="code" href="classOgre_1_1Vector3.html#ab1f9e7702256f32156be4d7e0fdafd7e">z</a> &lt; mMinimum.z)
<a name="l00778"></a>00778                     maxDist = std::max(maxDist, mMinimum.z - v.<a class="code" href="classOgre_1_1Vector3.html#ab1f9e7702256f32156be4d7e0fdafd7e">z</a>);
<a name="l00779"></a>00779                 
<a name="l00780"></a>00780                 <span class="keywordflow">if</span> (v.<a class="code" href="classOgre_1_1Vector3.html#a27be092ad0b7e0504ddf4db5cd565f14">x</a> &gt; mMaximum.x)
<a name="l00781"></a>00781                     maxDist = std::max(maxDist, v.<a class="code" href="classOgre_1_1Vector3.html#a27be092ad0b7e0504ddf4db5cd565f14">x</a> - mMaximum.x);
<a name="l00782"></a>00782                 <span class="keywordflow">if</span> (v.<a class="code" href="classOgre_1_1Vector3.html#a05ca4492ce30a049ae4102e3f5e85aff">y</a> &gt; mMaximum.y)
<a name="l00783"></a>00783                     maxDist = std::max(maxDist, v.<a class="code" href="classOgre_1_1Vector3.html#a05ca4492ce30a049ae4102e3f5e85aff">y</a> - mMaximum.y);
<a name="l00784"></a>00784                 <span class="keywordflow">if</span> (v.<a class="code" href="classOgre_1_1Vector3.html#ab1f9e7702256f32156be4d7e0fdafd7e">z</a> &gt; mMaximum.z)
<a name="l00785"></a>00785                     maxDist = std::max(maxDist, v.<a class="code" href="classOgre_1_1Vector3.html#ab1f9e7702256f32156be4d7e0fdafd7e">z</a> - mMaximum.z);
<a name="l00786"></a>00786                 
<a name="l00787"></a>00787                 <span class="keywordflow">return</span> maxDist;
<a name="l00788"></a>00788             }
<a name="l00789"></a>00789         }
<a name="l00790"></a>00790 
<a name="l00793"></a><a class="code" href="classOgre_1_1AxisAlignedBox.html#ad7020d4221c8a7f35800a776f8d4dcb5">00793</a>         <span class="keywordtype">bool</span> contains(<span class="keyword">const</span> <a class="code" href="classOgre_1_1AxisAlignedBox.html" title="A 3D box aligned with the x/y/z axes.">AxisAlignedBox</a>&amp; other)<span class="keyword"> const</span>
<a name="l00794"></a>00794 <span class="keyword">        </span>{
<a name="l00795"></a>00795             <span class="keywordflow">if</span> (other.<a class="code" href="classOgre_1_1AxisAlignedBox.html#abeef4ea1111a90001287734529288749" title="Returns true if the box is null i.e.">isNull</a>() || this-&gt;isInfinite())
<a name="l00796"></a>00796                 <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00797"></a>00797 
<a name="l00798"></a>00798             <span class="keywordflow">if</span> (this-&gt;isNull() || other.<a class="code" href="classOgre_1_1AxisAlignedBox.html#a45665abec389ae0ecbea54a26956a633" title="Returns true if the box is infinite.">isInfinite</a>())
<a name="l00799"></a>00799                 <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00800"></a>00800 
<a name="l00801"></a>00801             <span class="keywordflow">return</span> this-&gt;mMinimum.x &lt;= other.<a class="code" href="classOgre_1_1AxisAlignedBox.html#a958c03c0afd2eef4347d345bea8c94a5">mMinimum</a>.<a class="code" href="classOgre_1_1Vector3.html#a27be092ad0b7e0504ddf4db5cd565f14">x</a> &amp;&amp;
<a name="l00802"></a>00802                    this-&gt;mMinimum.y &lt;= other.<a class="code" href="classOgre_1_1AxisAlignedBox.html#a958c03c0afd2eef4347d345bea8c94a5">mMinimum</a>.<a class="code" href="classOgre_1_1Vector3.html#a05ca4492ce30a049ae4102e3f5e85aff">y</a> &amp;&amp;
<a name="l00803"></a>00803                    this-&gt;mMinimum.z &lt;= other.<a class="code" href="classOgre_1_1AxisAlignedBox.html#a958c03c0afd2eef4347d345bea8c94a5">mMinimum</a>.<a class="code" href="classOgre_1_1Vector3.html#ab1f9e7702256f32156be4d7e0fdafd7e">z</a> &amp;&amp;
<a name="l00804"></a>00804                    other.<a class="code" href="classOgre_1_1AxisAlignedBox.html#a2254e8ef682cda1a96693637742c9834">mMaximum</a>.<a class="code" href="classOgre_1_1Vector3.html#a27be092ad0b7e0504ddf4db5cd565f14">x</a> &lt;= this-&gt;mMaximum.x &amp;&amp;
<a name="l00805"></a>00805                    other.<a class="code" href="classOgre_1_1AxisAlignedBox.html#a2254e8ef682cda1a96693637742c9834">mMaximum</a>.<a class="code" href="classOgre_1_1Vector3.html#a05ca4492ce30a049ae4102e3f5e85aff">y</a> &lt;= this-&gt;mMaximum.y &amp;&amp;
<a name="l00806"></a>00806                    other.<a class="code" href="classOgre_1_1AxisAlignedBox.html#a2254e8ef682cda1a96693637742c9834">mMaximum</a>.<a class="code" href="classOgre_1_1Vector3.html#ab1f9e7702256f32156be4d7e0fdafd7e">z</a> &lt;= this-&gt;mMaximum.z;
<a name="l00807"></a>00807         }
<a name="l00808"></a>00808 
<a name="l00811"></a><a class="code" href="classOgre_1_1AxisAlignedBox.html#a60fe1a0464ed6991c3ec82fada37bb17">00811</a>         <span class="keywordtype">bool</span> <a class="code" href="group__Memory.html#gaa5b83b2ba3ce965e3d8dd129c93ee43b" title="determine equality, can memory from another allocator be released by this allocator, (ISO C++)">operator== </a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1AxisAlignedBox.html" title="A 3D box aligned with the x/y/z axes.">AxisAlignedBox</a>&amp; rhs)<span class="keyword"> const</span>
<a name="l00812"></a>00812 <span class="keyword">        </span>{
<a name="l00813"></a>00813             <span class="keywordflow">if</span> (this-&gt;mExtent != rhs.<a class="code" href="classOgre_1_1AxisAlignedBox.html#a756e8324082dc0b9f1d7926847711ef4">mExtent</a>)
<a name="l00814"></a>00814                 <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00815"></a>00815 
<a name="l00816"></a>00816             <span class="keywordflow">if</span> (!this-&gt;isFinite())
<a name="l00817"></a>00817                 <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00818"></a>00818 
<a name="l00819"></a>00819             <span class="keywordflow">return</span> this-&gt;mMinimum == rhs.<a class="code" href="classOgre_1_1AxisAlignedBox.html#a958c03c0afd2eef4347d345bea8c94a5">mMinimum</a> &amp;&amp;
<a name="l00820"></a>00820                    this-&gt;mMaximum == rhs.<a class="code" href="classOgre_1_1AxisAlignedBox.html#a2254e8ef682cda1a96693637742c9834">mMaximum</a>;
<a name="l00821"></a>00821         }
<a name="l00822"></a>00822 
<a name="l00825"></a><a class="code" href="classOgre_1_1AxisAlignedBox.html#ad9a9f1e39dbb38220f1e416b188082ab">00825</a>         <span class="keywordtype">bool</span> <a class="code" href="group__Memory.html#ga34a9308dc656f694883718bf8fa4f1c2" title="determine equality, can memory from another allocator be released by this allocator, (ISO C++)">operator!= </a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1AxisAlignedBox.html" title="A 3D box aligned with the x/y/z axes.">AxisAlignedBox</a>&amp; rhs)<span class="keyword"> const</span>
<a name="l00826"></a>00826 <span class="keyword">        </span>{
<a name="l00827"></a>00827             <span class="keywordflow">return</span> !(*<span class="keyword">this</span> == rhs);
<a name="l00828"></a>00828         }
<a name="l00829"></a>00829 
<a name="l00830"></a>00830         <span class="comment">// special values</span>
<a name="l00831"></a><a class="code" href="classOgre_1_1AxisAlignedBox.html#a4d1a5a62c7c38d0831c6073f7343f70f">00831</a>         <span class="keyword">static</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1AxisAlignedBox.html" title="A 3D box aligned with the x/y/z axes.">AxisAlignedBox</a> <a class="code" href="classOgre_1_1AxisAlignedBox.html#a4d1a5a62c7c38d0831c6073f7343f70f">BOX_NULL</a>;
<a name="l00832"></a><a class="code" href="classOgre_1_1AxisAlignedBox.html#ad1b10226c7dd82d5714f8d50c5fd4e04">00832</a>         <span class="keyword">static</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1AxisAlignedBox.html" title="A 3D box aligned with the x/y/z axes.">AxisAlignedBox</a> <a class="code" href="classOgre_1_1AxisAlignedBox.html#ad1b10226c7dd82d5714f8d50c5fd4e04">BOX_INFINITE</a>;
<a name="l00833"></a>00833 
<a name="l00834"></a>00834 
<a name="l00835"></a>00835     };
<a name="l00836"></a>00836 
<a name="l00839"></a>00839 } <span class="comment">// namespace Ogre</span>
<a name="l00840"></a>00840 
<a name="l00841"></a>00841 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:49
</p>
</body>
</html>
